"""dashboard and dashboard_kpi_mapper

Revision ID: f7d137e094dd
Revises: 7c504acbf3c4
Create Date: 2021-11-23 08:40:55.497857

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'f7d137e094dd'
down_revision = '7c504acbf3c4'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('dashboard',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=80), nullable=False),
    sa.Column('active', sa.Boolean(), nullable=True),
    sa.Column('last_modified', sa.DateTime(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('dashboard_kpi_mapper',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('dashboard', sa.Integer(), nullable=False),
    sa.Column('kpi', sa.Integer(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('active', sa.Boolean(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_dashboard_kpi_mapper_dashboard'), 'dashboard_kpi_mapper', ['dashboard'], unique=False)
    op.create_index(op.f('ix_dashboard_kpi_mapper_kpi'), 'dashboard_kpi_mapper', ['kpi'], unique=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_dashboard_kpi_mapper_kpi'), table_name='dashboard_kpi_mapper')
    op.drop_index(op.f('ix_dashboard_kpi_mapper_dashboard'), table_name='dashboard_kpi_mapper')
    op.drop_table('dashboard_kpi_mapper')
    op.drop_table('dashboard')
    # ### end Alembic commands ###
